#include <stdio.h>
#ifdef WIN32
	#include <windows.h>
	#include <process.h>
#elif SYLLABLE
	#include <atheos/threads.h>
	#include <signal.h> /* kill function */
#endif

#include "IRC.h"


int end_of_motd(char* params, irc_reply_data* hostd, void* conn) /* our callback function */
{
	IRC* irc_conn=(IRC*)conn;

	irc_conn->join("#magpie"); /* join the channel #magpie */
	return 0;
}

void cmd_thread(void* irc_conn) /* another thread just to wait until a key is pressed, and then quit */
{
	IRC* conn=(IRC*)irc_conn;

	getc(stdin); /* read in a character from standard in */
	conn->quit("Leaving"); /* send the Quit command to the IRC server */

	/* end the thread */
#ifdef WIN32
	_endthread();
#elif SYLLABLE
	thread_info sInfo;
	kill( sInfo.ti_thread_id, 9 );
#endif
}

int main()
{
	IRC conn; /* declare an IRC connection */

#ifdef WIN32
	WSADATA wsaData; /* winsock stuff, linux/unix/\*bsd users need not worry about this */

	if (WSAStartup(MAKEWORD(1, 1), &wsaData)) /* more winsock rubbish */
	{
	printf("Failed to initialise winsock!\n");
	}
#endif
	conn.hook_irc_command("376", &end_of_motd); /* hook the end of MOTD message */

#ifdef WIN32
	_beginthread(cmd_thread, 0, (void*)&conn); /* spawn our key input thread */
#elif SYLLABLE
	thread_id g_hReadThread = spawn_thread( "kbd_thread", (void*)cmd_thread, NORMAL_PRIORITY, 0, (void*)&conn);
	resume_thread( g_hReadThread );
#endif

	conn.start("irc.uk.quakenet.org", 6668, "cpirctest", "cpirctest", "cpIRC test", "password"); /* connect to a server */
	conn.message_loop(); /* start the message loop */

#ifdef WIN32
	WSACleanup(); /* more winsock stuff */
#endif
}
